Index: /LMDZ4/trunk/libf/phylmd/phyetat0.F
===================================================================
--- /LMDZ4/trunk/libf/phylmd/phyetat0.F	(revision 1000)
+++ /LMDZ4/trunk/libf/phylmd/phyetat0.F	(revision 1001)
@@ -17,5 +17,6 @@
       USE surface_data,     ONLY : type_ocean
       USE phys_state_var_mod
-
+      USE iostart
+      USE write_field_phy
       IMPLICIT none
 c======================================================================
@@ -35,57 +36,16 @@
 
 c les variables globales lues dans le fichier restart
-      REAL rlat_glo(klon_glo), rlon_glo(klon_glo)
-      REAL pctsrf_glo(klon_glo, nbsrf)
-      REAL tsol_glo(klon_glo,nbsrf)
-      REAL alb1_glo(klon_glo,nbsrf)
-      REAL alb2_glo(klon_glo,nbsrf)
-      REAL rain_fall_glo(klon_glo)
-      REAL snow_fall_glo(klon_glo)
-      real solsw_glo(klon_glo)
-      real sollw_glo(klon_glo)
-      REAL radsol_glo(klon_glo)
-      REAL zmea_glo(klon_glo)
-      REAL zstd_glo(klon_glo)
-      REAL zsig_glo(klon_glo)
-      REAL zgam_glo(klon_glo)
-      REAL zthe_glo(klon_glo)
-      REAL zpic_glo(klon_glo)
-      REAL zval_glo(klon_glo)
-      REAL rugsrel_glo(klon_glo)
-      REAL t_ancien_glo(klon_glo,klev), q_ancien_glo(klon_glo,klev)
-      REAL clwcon_glo(klon_glo,klev)
-      REAL rnebcon_glo(klon_glo,klev) 
-      REAL ratqs_glo(klon_glo,klev)
-      REAL pbl_tke_glo(klon_glo,klev+1,nbsrf)
-      REAL zmax0_glo(klon_glo), f0_glo(klon)
-      REAL ema_work1_glo(klon_glo, klev), ema_work2_glo(klon_glo, klev)
-      REAL wake_deltat_glo(klon_glo,klev)
-      REAL wake_deltaq_glo(klon_glo,klev)
-      REAL wake_s_glo(klon_glo), wake_cstar_glo(klon_glo)
-      REAL wake_fip_glo(klon_glo)
-      REAL tsoil_p(klon,nsoilmx,nbsrf)
-      REAL qsurf_p(klon,nbsrf)
-      REAL qsol_p(klon)
-      REAL snow_p(klon,nbsrf)
-      REAL evap_p(klon,nbsrf)
-      real fder_p(klon)
-      REAL frugs_p(klon,nbsrf)
-      REAL agesno_p(klon,nbsrf)
-      REAL run_off_lic_0_p(klon)
-      
-      LOGICAL,SAVE ::  ancien_ok_glo
-!$OMP THREADPRIVATE(ancien_ok_glo)  
-    
-      REAL zmasq_glo(klon_glo)
-      REAL tsoil(klon_glo,nsoilmx,nbsrf)
-      REAL qsurf(klon_glo,nbsrf)
-      REAL qsol(klon_glo)
-      REAL snow(klon_glo,nbsrf)
-      REAL evap(klon_glo,nbsrf)
-      real fder(klon_glo)
-      REAL frugs(klon_glo,nbsrf)
-      REAL agesno(klon_glo,nbsrf)
-      REAL fractint(klon_glo)
-      REAL run_off_lic_0(klon_glo)
+
+      REAL tsoil(klon,nsoilmx,nbsrf)
+      REAL tslab(klon), seaice(klon)
+      REAL qsurf(klon,nbsrf)
+      REAL qsol(klon)
+      REAL snow(klon,nbsrf)
+      REAL evap(klon,nbsrf)
+      real fder(klon)
+      REAL frugs(klon,nbsrf)
+      REAL agesno(klon,nbsrf)
+      REAL run_off_lic_0(klon)
+      REAL fractint(klon)
 
       CHARACTER*6 ocean_in
@@ -105,4 +65,5 @@
       CHARACTER*7 str7
       CHARACTER*2 str2
+      LOGICAL :: found
 
 c FH1D
@@ -113,44 +74,12 @@
 c
 
-c$OMP MASTER
-      print *,'MASTER -x , omp_rank=',omp_rank
-c$OMP END MASTER
-
-c$OMP MASTER
-      IF (is_mpi_root) THEN
-        print*,'fichnom ',fichnom
-        ierr = NF_OPEN (fichnom, NF_NOWRITE,nid)
-        IF (ierr.NE.NF_NOERR) THEN
-          write(6,*)' Pb d''ouverture du fichier '//fichnom
-          write(6,*)' ierr = ', ierr
-          CALL ABORT
-        ENDIF
-      ENDIF
-c$OMP END MASTER
+     
+      CALL open_startphy(fichnom)
+      
+
 c
 c Lecture des parametres de controle:
 c
-c$OMP MASTER
-      IF (is_mpi_root) THEN
-      
-      ierr = NF_INQ_VARID (nid, "controle", nvarid)
-      IF (ierr.NE.NF_NOERR) THEN
-         PRINT*, 'phyetat0: Le champ <controle> est absent'
-         CALL abort
-      ENDIF
-#ifdef NC_DOUBLE
-      ierr = NF_GET_VAR_DOUBLE(nid, nvarid, tab_cntrl)
-#else
-      ierr = NF_GET_VAR_REAL(nid, nvarid, tab_cntrl)
-#endif
-      IF (ierr.NE.NF_NOERR) THEN
-         PRINT*, 'phyetat0: Lecture echouee pour <controle>'
-         CALL abort
-      ENDIF
-      ENDIF
-
-c$OMP END MASTER
-       
-       CALL bcast(tab_cntrl)
+      CALL get_var("controle",tab_cntrl)
        
 c
@@ -225,58 +154,19 @@
 c Lecture des latitudes (coordonnees):
 c
-      IF (is_mpi_root .AND. is_omp_root) THEN
-      
-      ierr = NF_INQ_VARID (nid, "latitude", nvarid)
-      IF (ierr.NE.NF_NOERR) THEN
-         PRINT*, 'phyetat0: Le champ <latitude> est absent'
-         CALL abort
-      ENDIF
-#ifdef NC_DOUBLE
-      ierr = NF_GET_VAR_DOUBLE(nid, nvarid, rlat_glo)
-#else
-      ierr = NF_GET_VAR_REAL(nid, nvarid, rlat_glo)
-#endif
-      IF (ierr.NE.NF_NOERR) THEN
-         PRINT*, 'phyetat0: Lecture echouee pour <latitude>'
-         CALL abort
-      ENDIF
+      CALL get_field("latitude",rlat)
 
 c
 c Lecture des longitudes (coordonnees):
 c
-      ierr = NF_INQ_VARID (nid, "longitude", nvarid)
-      IF (ierr.NE.NF_NOERR) THEN
-         PRINT*, 'phyetat0: Le champ <longitude> est absent'
-         CALL abort
-      ENDIF
-#ifdef NC_DOUBLE
-      ierr = NF_GET_VAR_DOUBLE(nid, nvarid, rlon_glo)
-#else
-      ierr = NF_GET_VAR_REAL(nid, nvarid, rlon_glo)
-#endif
-      IF (ierr.NE.NF_NOERR) THEN
-         PRINT*, 'phyetat0: Lecture echouee pour <latitude>'
-         CALL abort
-      ENDIF
+      CALL get_field("longitude",rlon)
+
 C
 C
 C Lecture du masque terre mer
 C
-
-      ierr = NF_INQ_VARID (nid, "masque", nvarid)
-      IF (ierr .EQ.  NF_NOERR) THEN
-#ifdef NC_DOUBLE
-          ierr = NF_GET_VAR_DOUBLE(nid, nvarid, zmasq_glo)
-#else
-          ierr = NF_GET_VAR_REAL(nid, nvarid, zmasq_glo)
-#endif
-          IF (ierr.NE.NF_NOERR) THEN
-              PRINT*, 'phyetat0: Lecture echouee pour <masque>'
-              CALL abort
-          ENDIF
-      else
-          PRINT*, 'phyetat0: Le champ <masque> est absent'
-          PRINT*, 'fichier startphy non compatible avec phyetat0'
-C      CALL abort
+      CALL get_field("masque",zmasq,found)
+      IF (.NOT. found) THEN
+        PRINT*, 'phyetat0: Le champ <masque> est absent'
+        PRINT *, 'fichier startphy non compatible avec phyetat0'
       ENDIF
 
@@ -291,103 +181,44 @@
 C
 
-      ierr = NF_INQ_VARID (nid, "FTER", nvarid)
-      IF (ierr .EQ.  NF_NOERR) THEN
-#ifdef NC_DOUBLE
-          ierr = NF_GET_VAR_DOUBLE(nid, nvarid,        
-     .                             pctsrf_glo(1 : klon_glo,is_ter))
-#else
-          ierr = NF_GET_VAR_REAL(nid, nvarid, 
-     .                           pctsrf_glo(1 : klon_glo,is_ter))
-#endif
-          IF (ierr.NE.NF_NOERR) THEN
-              PRINT*, 'phyetat0: Lecture echouee pour <FTER>'
-              CALL abort
-          ENDIF
-      else
-          PRINT*, 'phyetat0: Le champ <FTER> est absent'
-c@$$         CALL abort
-      ENDIF
+      CALL get_field("FTER",pctsrf(:,is_ter),found)
+      IF (.NOT. found) PRINT*, 'phyetat0: Le champ <FTER> est absent'
 
 C
 C fraction de glace de terre
 C
-      ierr = NF_INQ_VARID (nid, "FLIC", nvarid)
-      IF (ierr .EQ.  NF_NOERR) THEN
-#ifdef NC_DOUBLE
-          ierr = NF_GET_VAR_DOUBLE(nid, nvarid, 
-     .                             pctsrf_glo(1 : klon_glo,is_lic))
-#else
-          ierr = NF_GET_VAR_REAL(nid, nvarid, 
-     .                           pctsrf_glo(1 : klon_glo,is_lic))
-#endif
-          IF (ierr.NE.NF_NOERR) THEN
-              PRINT*, 'phyetat0: Lecture echouee pour <FLIC>'
-              CALL abort
-          ENDIF
-      else
-          PRINT*, 'phyetat0: Le champ <FLIC> est absent'
-c@$$         CALL abort
-      ENDIF
+      CALL get_field("FLIC",pctsrf(:,is_lic),found)
+      IF (.NOT. found) PRINT*, 'phyetat0: Le champ <FLIC> est absent'
+
 C
 C fraction d'ocean
 C
-      ierr = NF_INQ_VARID (nid, "FOCE", nvarid)
-      IF (ierr .EQ.  NF_NOERR) THEN
-#ifdef NC_DOUBLE
-          ierr = NF_GET_VAR_DOUBLE(nid, nvarid, 
-     .                             pctsrf_glo(1 : klon_glo,is_oce))
-#else
-          ierr = NF_GET_VAR_REAL(nid, nvarid, 
-     .                           pctsrf_glo(1 : klon_glo,is_oce))
-#endif
-          IF (ierr.NE.NF_NOERR) THEN
-              PRINT*, 'phyetat0: Lecture echouee pour <FOCE>'
-              CALL abort
-          ENDIF
-      else
-          PRINT*, 'phyetat0: Le champ <FOCE> est absent'
-c@$$         CALL abort
-      ENDIF
+      CALL get_field("FOCE",pctsrf(:,is_oce),found)
+      IF (.NOT. found) PRINT*, 'phyetat0: Le champ <FOCE> est absent'
 
 C
 C fraction glace de mer
 C
-      ierr = NF_INQ_VARID (nid, "FSIC", nvarid)
-      IF (ierr .EQ.  NF_NOERR) THEN
-#ifdef NC_DOUBLE
-          ierr = NF_GET_VAR_DOUBLE(nid, nvarid, 
-     .                             pctsrf_glo(1 : klon_glo,is_sic))
-#else
-          ierr = NF_GET_VAR_REAL(nid, nvarid, 
-     .                           pctsrf_glo(1 : klon_glo, is_sic))
-#endif
-          IF (ierr.NE.NF_NOERR) THEN
-              PRINT*, 'phyetat0: Lecture echouee pour <FSIC>'
-              CALL abort
-          ENDIF
-      else
-          PRINT*, 'phyetat0: Le champ <FSIC> est absent'
-c@$$         CALL abort
-      ENDIF
+      CALL get_field("FSIC",pctsrf(:,is_sic),found)
+      IF (.NOT. found) PRINT*, 'phyetat0: Le champ <FSIC> est absent'
 
 C
 C  Verification de l'adequation entre le masque et les sous-surfaces
 C
-      fractint( 1 : klon_glo) = pctsrf_glo(1 : klon_glo, is_ter) 
-     $    + pctsrf_glo(1 : klon_glo, is_lic)
-      DO i = 1 , klon_glo
-        IF ( abs(fractint(i) - zmasq_glo(i) ) .GT. EPSFRA ) THEN
+      fractint( 1 : klon) = pctsrf(1 : klon, is_ter) 
+     $    + pctsrf(1 : klon, is_lic)
+      DO i = 1 , klon
+        IF ( abs(fractint(i) - zmasq(i) ) .GT. EPSFRA ) THEN
             WRITE(*,*) 'phyetat0: attention fraction terre pas ', 
-     $          'coherente ', i, zmasq_glo(i), pctsrf_glo(i, is_ter)
-     $          ,pctsrf_glo(i, is_lic)
+     $          'coherente ', i, zmasq(i), pctsrf(i, is_ter)
+     $          ,pctsrf(i, is_lic)
         ENDIF 
       END DO 
-      fractint (1 : klon_glo) =  pctsrf_glo(1 : klon_glo, is_oce) 
-     $    + pctsrf_glo(1 : klon_glo, is_sic)
-      DO i = 1 , klon_glo
-        IF ( abs( fractint(i) - (1. - zmasq_glo(i))) .GT. EPSFRA ) THEN
+      fractint (1 : klon) =  pctsrf(1 : klon, is_oce) 
+     $    + pctsrf(1 : klon, is_sic)
+      DO i = 1 , klon
+        IF ( abs( fractint(i) - (1. - zmasq(i))) .GT. EPSFRA ) THEN
             WRITE(*,*) 'phyetat0 attention fraction ocean pas ', 
-     $          'coherente ', i, zmasq_glo(i) , pctsrf_glo(i, is_oce)
-     $          ,pctsrf_glo(i, is_sic)
+     $          'coherente ', i, zmasq(i) , pctsrf(i, is_oce)
+     $          ,pctsrf(i, is_sic)
         ENDIF 
       END DO 
@@ -397,6 +228,6 @@
 c
 
-      ierr = NF_INQ_VARID (nid, "TS", nvarid)
-      IF (ierr.NE.NF_NOERR) THEN
+       CALL get_field("TS",ftsol(:,1),found)
+       IF (.NOT. found) THEN
          PRINT*, 'phyetat0: Le champ <TS> est absent'
          PRINT*, '          Mais je vais essayer de lire TS**'
@@ -407,24 +238,11 @@
            ENDIF
            WRITE(str2,'(i2.2)') nsrf
-           ierr = NF_INQ_VARID (nid, "TS"//str2, nvarid)
-           IF (ierr.NE.NF_NOERR) THEN
-              PRINT*, "phyetat0: Le champ <TS"//str2//"> est absent"
-              CALL abort
-           ENDIF
-#ifdef NC_DOUBLE
-           ierr = NF_GET_VAR_DOUBLE(nid, nvarid, tsol_glo(1,nsrf))
-#else
-           ierr = NF_GET_VAR_REAL(nid, nvarid, tsol_glo(1,nsrf))
-#endif
-           IF (ierr.NE.NF_NOERR) THEN
-             PRINT*, "phyetat0: Lecture echouee pour <TS"//str2//">"
-             CALL abort
-           ENDIF
+           CALL get_field("TS"//str2,ftsol(:,nsrf))
 
            xmin = 1.0E+20
            xmax = -1.0E+20
-           DO i = 1, klon_glo
-              xmin = MIN(tsol_glo(i,nsrf),xmin)
-              xmax = MAX(tsol_glo(i,nsrf),xmax)
+           DO i = 1, klon
+              xmin = MIN(ftsol(i,nsrf),xmin)
+              xmax = MAX(ftsol(i,nsrf),xmax)
            ENDDO
            PRINT*,'Temperature du sol TS**:', nsrf, xmin, xmax
@@ -433,23 +251,14 @@
          PRINT*, 'phyetat0: Le champ <TS> est present'
          PRINT*, '          J ignore donc les autres temperatures TS**'
-#ifdef NC_DOUBLE
-         ierr = NF_GET_VAR_DOUBLE(nid, nvarid, tsol_glo(1,1))
-#else
-         ierr = NF_GET_VAR_REAL(nid, nvarid, tsol_glo(1,1))
-#endif
-         IF (ierr.NE.NF_NOERR) THEN
-            PRINT*, "phyetat0: Lecture echouee pour <TS>"
-            CALL abort
-         ENDIF
          xmin = 1.0E+20
          xmax = -1.0E+20
-         DO i = 1, klon_glo
-            xmin = MIN(tsol_glo(i,1),xmin)
-            xmax = MAX(tsol_glo(i,1),xmax)
+         DO i = 1, klon
+            xmin = MIN(ftsol(i,1),xmin)
+            xmax = MAX(ftsol(i,1),xmax)
          ENDDO
          PRINT*,'Temperature du sol <TS>', xmin, xmax
          DO nsrf = 2, nbsrf
-         DO i = 1, klon_glo
-            tsol_glo(i,nsrf) = tsol_glo(i,1)
+         DO i = 1, klon
+            ftsol(i,nsrf) = ftsol(i,1)
          ENDDO
          ENDDO
@@ -460,35 +269,27 @@
 c
       DO nsrf = 1, nbsrf
-      DO isoil=1, nsoilmx
-      IF (isoil.GT.99 .AND. nsrf.GT.99) THEN
-         PRINT*, "Trop de couches ou sous-mailles"
-         CALL abort
-      ENDIF
-      WRITE(str7,'(i2.2,"srf",i2.2)') isoil, nsrf
-      ierr = NF_INQ_VARID (nid, 'Tsoil'//str7, nvarid)
-      IF (ierr.NE.NF_NOERR) THEN
-         PRINT*, "phyetat0: Le champ <Tsoil"//str7//"> est absent"
-         PRINT*, "          Il prend donc la valeur de surface"
-         DO i=1, klon_glo
-             tsoil(i,isoil,nsrf)=tsol_glo(i,nsrf)
-         ENDDO
-      ELSE
-#ifdef NC_DOUBLE
-         ierr = NF_GET_VAR_DOUBLE(nid, nvarid, tsoil(1,isoil,nsrf))
-#else
-         ierr = NF_GET_VAR_REAL(nid, nvarid, tsoil(1,isoil,nsrf))
-#endif
-         IF (ierr.NE.NF_NOERR) THEN
-            PRINT*, "Lecture echouee pour <Tsoil"//str7//">"
+        DO isoil=1, nsoilmx
+          IF (isoil.GT.99 .AND. nsrf.GT.99) THEN
+            PRINT*, "Trop de couches ou sous-mailles"
             CALL abort
-         ENDIF
-      ENDIF
-      ENDDO
+          ENDIF
+          WRITE(str7,'(i2.2,"srf",i2.2)') isoil, nsrf
+          
+          CALL get_field('Tsoil'//str7,tsoil(:,isoil,nsrf),found)
+          IF (.NOT. found) THEN
+            PRINT*, "phyetat0: Le champ <Tsoil"//str7//"> est absent"
+            PRINT*, "          Il prend donc la valeur de surface"
+            DO i=1, klon
+               tsoil(i,isoil,nsrf)=ftsol(i,nsrf)
+            ENDDO
+          ENDIF
+        ENDDO
       ENDDO
 c
 c Lecture de l'humidite de l'air juste au dessus du sol:
 c
-      ierr = NF_INQ_VARID (nid, "QS", nvarid)
-      IF (ierr.NE.NF_NOERR) THEN
+
+      CALL get_field("QS",qsurf(:,1),found)
+      IF (.NOT. found) THEN
          PRINT*, 'phyetat0: Le champ <QS> est absent'
          PRINT*, '          Mais je vais essayer de lire QS**'
@@ -499,21 +300,8 @@
            ENDIF
            WRITE(str2,'(i2.2)') nsrf
-           ierr = NF_INQ_VARID (nid, "QS"//str2, nvarid)
-           IF (ierr.NE.NF_NOERR) THEN
-              PRINT*, "phyetat0: Le champ <QS"//str2//"> est absent"
-              CALL abort
-           ENDIF
-#ifdef NC_DOUBLE
-           ierr = NF_GET_VAR_DOUBLE(nid, nvarid, qsurf(1,nsrf))
-#else
-           ierr = NF_GET_VAR_REAL(nid, nvarid, qsurf(1,nsrf))
-#endif
-           IF (ierr.NE.NF_NOERR) THEN
-             PRINT*, "phyetat0: Lecture echouee pour <QS"//str2//">"
-             CALL abort
-           ENDIF
+           CALL get_field("QS"//str2,qsurf(:,nsrf))
            xmin = 1.0E+20
            xmax = -1.0E+20
-           DO i = 1, klon_glo
+           DO i = 1, klon
               xmin = MIN(qsurf(i,nsrf),xmin)
               xmax = MAX(qsurf(i,nsrf),xmax)
@@ -524,16 +312,7 @@
          PRINT*, 'phyetat0: Le champ <QS> est present'
          PRINT*, '          J ignore donc les autres humidites QS**'
-#ifdef NC_DOUBLE
-         ierr = NF_GET_VAR_DOUBLE(nid, nvarid, qsurf(1,1))
-#else
-         ierr = NF_GET_VAR_REAL(nid, nvarid, qsurf(1,1))
-#endif
-         IF (ierr.NE.NF_NOERR) THEN
-            PRINT*, "phyetat0: Lecture echouee pour <QS>"
-            CALL abort
-         ENDIF
          xmin = 1.0E+20
          xmax = -1.0E+20
-         DO i = 1, klon_glo
+         DO i = 1, klon
             xmin = MIN(qsurf(i,1),xmin)
             xmax = MAX(qsurf(i,1),xmax)
@@ -541,86 +320,57 @@
          PRINT*,'Humidite pres du sol <QS>', xmin, xmax
          DO nsrf = 2, nbsrf
-         DO i = 1, klon_glo
-            qsurf(i,nsrf) = qsurf(i,1)
-         ENDDO
-         ENDDO
-      ENDIF
+           DO i = 1, klon
+             qsurf(i,nsrf) = qsurf(i,1)
+           ENDDO
+         ENDDO
+      ENDIF
+
 C
 C Eau dans le sol (pour le modele de sol "bucket")
 C
-      ierr = NF_INQ_VARID (nid, "QSOL", nvarid)
-      IF (ierr .EQ.  NF_NOERR) THEN
-#ifdef NC_DOUBLE
-          ierr = NF_GET_VAR_DOUBLE(nid, nvarid, qsol)
-#else
-          ierr = NF_GET_VAR_REAL(nid, nvarid, qsol)
-#endif
-          IF (ierr.NE.NF_NOERR) THEN
-              PRINT*, 'phyetat0: Lecture echouee pour <QSOL>'
-              CALL abort
-          ENDIF
-      else
-          PRINT*, 'phyetat0: Le champ <QSOL> est absent'
-          PRINT*, '          Valeur par defaut nulle'
+      CALL get_field("QSOL",qsol,found)
+      IF (.NOT. found) THEN
+        PRINT*, 'phyetat0: Le champ <QSOL> est absent'
+        PRINT*, '          Valeur par defaut nulle'
           qsol(:)=0.
-c@$$         CALL abort
-      ENDIF
-      xmin = 1.0E+20
-      xmax = -1.0E+20
-      DO i = 1, klon_glo
+      ENDIF
+
+      xmin = 1.0E+20
+      xmax = -1.0E+20
+      DO i = 1, klon
         xmin = MIN(qsol(i),xmin)
         xmax = MAX(qsol(i),xmax)
       ENDDO
       PRINT*,'Eau dans le sol (mm) <QSOL>', xmin, xmax
+
 c
 c Lecture de neige au sol:
 c
-      ierr = NF_INQ_VARID (nid, "SNOW", nvarid)
-      IF (ierr.NE.NF_NOERR) THEN
-         PRINT*, 'phyetat0: Le champ <SNOW> est absent'
-         PRINT*, '          Mais je vais essayer de lire SNOW**'
-         DO nsrf = 1, nbsrf
-           IF (nsrf.GT.99) THEN
-             PRINT*, "Trop de sous-mailles"
-             CALL abort
-           ENDIF
-           WRITE(str2,'(i2.2)') nsrf
-           ierr = NF_INQ_VARID (nid, "SNOW"//str2, nvarid)
-           IF (ierr.NE.NF_NOERR) THEN
-              PRINT*, "phyetat0: Le champ <SNOW"//str2//"> est absent"
-              CALL abort
-           ENDIF
-#ifdef NC_DOUBLE
-           ierr = NF_GET_VAR_DOUBLE(nid, nvarid, snow(1,nsrf))
-#else
-           ierr = NF_GET_VAR_REAL(nid, nvarid, snow(1,nsrf))
-#endif
-           IF (ierr.NE.NF_NOERR) THEN
-             PRINT*, "phyetat0: Lecture echouee pour <SNOW"//str2//">"
-             CALL abort
-           ENDIF
-           xmin = 1.0E+20
-           xmax = -1.0E+20
-           DO i = 1, klon_glo
-              xmin = MIN(snow(i,nsrf),xmin)
-              xmax = MAX(snow(i,nsrf),xmax)
-           ENDDO
-           PRINT*,'Neige du sol SNOW**:', nsrf, xmin, xmax
-         ENDDO
+
+      CALL get_field("SNOW",snow(:,nsrf),found)
+      IF (.NOT. found) THEN
+        PRINT*, 'phyetat0: Le champ <SNOW> est absent'
+        PRINT*, '          Mais je vais essayer de lire SNOW**'
+        DO nsrf = 1, nbsrf
+          IF (nsrf.GT.99) THEN
+            PRINT*, "Trop de sous-mailles"
+            CALL abort
+          ENDIF
+          WRITE(str2,'(i2.2)') nsrf
+          CALL get_field( "SNOW"//str2,snow(:,nsrf))
+          xmin = 1.0E+20
+          xmax = -1.0E+20
+          DO i = 1, klon
+            xmin = MIN(snow(i,nsrf),xmin)
+            xmax = MAX(snow(i,nsrf),xmax)
+          ENDDO
+          PRINT*,'Neige du sol SNOW**:', nsrf, xmin, xmax
+        ENDDO
       ELSE
          PRINT*, 'phyetat0: Le champ <SNOW> est present'
          PRINT*, '          J ignore donc les autres neiges SNOW**'
-#ifdef NC_DOUBLE
-         ierr = NF_GET_VAR_DOUBLE(nid, nvarid, snow(1,1))
-#else
-         ierr = NF_GET_VAR_REAL(nid, nvarid, snow(1,1))
-#endif
-         IF (ierr.NE.NF_NOERR) THEN
-            PRINT*, "phyetat0: Lecture echouee pour <SNOW>"
-            CALL abort
-         ENDIF
          xmin = 1.0E+20
          xmax = -1.0E+20
-         DO i = 1, klon_glo
+         DO i = 1, klon
             xmin = MIN(snow(i,1),xmin)
             xmax = MAX(snow(i,1),xmax)
@@ -628,5 +378,5 @@
          PRINT*,'Neige du sol <SNOW>', xmin, xmax
          DO nsrf = 2, nbsrf
-         DO i = 1, klon_glo
+         DO i = 1, klon
             snow(i,nsrf) = snow(i,1)
          ENDDO
@@ -636,6 +386,6 @@
 c Lecture de albedo de l'interval visible au sol:
 c
-      ierr = NF_INQ_VARID (nid, "ALBE", nvarid)
-      IF (ierr.NE.NF_NOERR) THEN
+      CALL get_field("ALBE",falb1(:,1),found)
+      IF (.NOT. found) THEN
          PRINT*, 'phyetat0: Le champ <ALBE> est absent'
          PRINT*, '          Mais je vais essayer de lire ALBE**'
@@ -646,23 +396,10 @@
            ENDIF
            WRITE(str2,'(i2.2)') nsrf
-           ierr = NF_INQ_VARID (nid, "ALBE"//str2, nvarid)
-           IF (ierr.NE.NF_NOERR) THEN
-              PRINT*, "phyetat0: Le champ <ALBE"//str2//"> est absent"
-              CALL abort
-           ENDIF
-#ifdef NC_DOUBLE
-           ierr = NF_GET_VAR_DOUBLE(nid, nvarid, alb1_glo(1,nsrf))
-#else
-           ierr = NF_GET_VAR_REAL(nid, nvarid, alb1_glo(1,nsrf))
-#endif
-           IF (ierr.NE.NF_NOERR) THEN
-             PRINT*, "phyetat0: Lecture echouee pour <ALBE"//str2//">"
-             CALL abort
-           ENDIF
+           CALL get_field("ALBE"//str2,falb1(:,nsrf))
            xmin = 1.0E+20
            xmax = -1.0E+20
-           DO i = 1, klon_glo
-              xmin = MIN(alb1_glo(i,nsrf),xmin)
-              xmax = MAX(alb1_glo(i,nsrf),xmax)
+           DO i = 1, klon
+              xmin = MIN(falb1(i,nsrf),xmin)
+              xmax = MAX(falb1(i,nsrf),xmax)
            ENDDO
            PRINT*,'Albedo du sol ALBE**:', nsrf, xmin, xmax
@@ -671,24 +408,15 @@
          PRINT*, 'phyetat0: Le champ <ALBE> est present'
          PRINT*, '          J ignore donc les autres ALBE**'
-#ifdef NC_DOUBLE
-         ierr = NF_GET_VAR_DOUBLE(nid, nvarid, alb1_glo(1,1))
-#else
-         ierr = NF_GET_VAR_REAL(nid, nvarid, alb1_glo(1,1))
-#endif
-         IF (ierr.NE.NF_NOERR) THEN
-            PRINT*, "phyetat0: Lecture echouee pour <ALBE>"
-            CALL abort
-         ENDIF
          xmin = 1.0E+20
          xmax = -1.0E+20
-         DO i = 1, klon_glo
-            xmin = MIN(alb1_glo(i,1),xmin)
-            xmax = MAX(alb1_glo(i,1),xmax)
+         DO i = 1, klon
+            xmin = MIN(falb1(i,1),xmin)
+            xmax = MAX(falb1(i,1),xmax)
          ENDDO
          PRINT*,'Neige du sol <ALBE>', xmin, xmax
          DO nsrf = 2, nbsrf
-         DO i = 1, klon_glo
-            alb1_glo(i,nsrf) = alb1_glo(i,1)
-         ENDDO
+           DO i = 1, klon
+            falb1(i,nsrf) = falb1(i,1)
+           ENDDO
          ENDDO
       ENDIF
@@ -697,12 +425,11 @@
 c Lecture de albedo au sol dans l'interval proche infra-rouge:
 c
-      ierr = NF_INQ_VARID (nid, "ALBLW", nvarid)
-      IF (ierr.NE.NF_NOERR) THEN
+      CALL get_field("ALBLW",falb2(:,1),found)
+      IF (.NOT. found) THEN
          PRINT*, 'phyetat0: Le champ <ALBLW> est absent'
-c        PRINT*, '          Mais je vais essayer de lire ALBLW**'
          PRINT*, '          Mais je vais prendre ALBE**'
          DO nsrf = 1, nbsrf
-           DO i = 1, klon_glo
-             alb2_glo(i,nsrf) = alb1_glo(i,nsrf)
+           DO i = 1, klon
+             falb2(i,nsrf) = falb1(i,nsrf)
            ENDDO
          ENDDO
@@ -710,24 +437,15 @@
          PRINT*, 'phyetat0: Le champ <ALBLW> est present'
          PRINT*, '          J ignore donc les autres ALBLW**'
-#ifdef NC_DOUBLE
-         ierr = NF_GET_VAR_DOUBLE(nid, nvarid, alb2_glo(1,1))
-#else
-         ierr = NF_GET_VAR_REAL(nid, nvarid, alb2_glo(1,1))
-#endif
-         IF (ierr.NE.NF_NOERR) THEN
-            PRINT*, "phyetat0: Lecture echouee pour <ALBLW>"
-            CALL abort
-         ENDIF
          xmin = 1.0E+20
          xmax = -1.0E+20
-         DO i = 1, klon_glo
-            xmin = MIN(alb2_glo(i,1),xmin)
-            xmax = MAX(alb2_glo(i,1),xmax)
+         DO i = 1, klon
+            xmin = MIN(falb2(i,1),xmin)
+            xmax = MAX(falb2(i,1),xmax)
          ENDDO
          PRINT*,'Neige du sol <ALBLW>', xmin, xmax
          DO nsrf = 2, nbsrf
-         DO i = 1, klon_glo
-            alb2_glo(i,nsrf) = alb2_glo(i,1)
-         ENDDO
+           DO i = 1, klon
+             falb2(i,nsrf) = falb2(i,1)
+           ENDDO
          ENDDO
       ENDIF
@@ -735,6 +453,6 @@
 c Lecture de evaporation:  
 c
-      ierr = NF_INQ_VARID (nid, "EVAP", nvarid)
-      IF (ierr.NE.NF_NOERR) THEN
+      CALL get_field("EVAP",evap(:,1),found)
+      IF (.NOT. found) THEN
          PRINT*, 'phyetat0: Le champ <EVAP> est absent'
          PRINT*, '          Mais je vais essayer de lire EVAP**'
@@ -745,21 +463,8 @@
            ENDIF
            WRITE(str2,'(i2.2)') nsrf
-           ierr = NF_INQ_VARID (nid, "EVAP"//str2, nvarid)
-           IF (ierr.NE.NF_NOERR) THEN
-              PRINT*, "phyetat0: Le champ <EVAP"//str2//"> est absent"
-              CALL abort
-           ENDIF
-#ifdef NC_DOUBLE
-           ierr = NF_GET_VAR_DOUBLE(nid, nvarid, evap(1,nsrf))
-#else
-           ierr = NF_GET_VAR_REAL(nid, nvarid, evap(1,nsrf))
-#endif
-           IF (ierr.NE.NF_NOERR) THEN
-             PRINT*, "phyetat0: Lecture echouee pour <EVAP"//str2//">"
-             CALL abort
-           ENDIF
+           CALL get_field("EVAP"//str2, evap(:,nsrf))
            xmin = 1.0E+20
            xmax = -1.0E+20
-           DO i = 1, klon_glo
+           DO i = 1, klon
               xmin = MIN(evap(i,nsrf),xmin)
               xmax = MAX(evap(i,nsrf),xmax)
@@ -770,16 +475,7 @@
          PRINT*, 'phyetat0: Le champ <EVAP> est present'
          PRINT*, '          J ignore donc les autres EVAP**'
-#ifdef NC_DOUBLE
-         ierr = NF_GET_VAR_DOUBLE(nid, nvarid, evap(1,1))
-#else
-         ierr = NF_GET_VAR_REAL(nid, nvarid, evap(1,1))
-#endif
-         IF (ierr.NE.NF_NOERR) THEN
-            PRINT*, "phyetat0: Lecture echouee pour <EVAP>"
-            CALL abort
-         ENDIF
          xmin = 1.0E+20
          xmax = -1.0E+20
-         DO i = 1, klon_glo
+         DO i = 1, klon
             xmin = MIN(evap(i,1),xmin)
             xmax = MAX(evap(i,1),xmax)
@@ -787,5 +483,5 @@
          PRINT*,'Evap du sol <EVAP>', xmin, xmax
          DO nsrf = 2, nbsrf
-         DO i = 1, klon_glo
+         DO i = 1, klon
             evap(i,nsrf) = evap(i,1)
          ENDDO
@@ -795,23 +491,10 @@
 c Lecture precipitation liquide:
 c
-      ierr = NF_INQ_VARID (nid, "rain_f", nvarid)
-      IF (ierr.NE.NF_NOERR) THEN
-         PRINT*, 'phyetat0: Le champ <rain_f> est absent'
-         CALL abort
-      ENDIF
-#ifdef NC_DOUBLE
-      ierr = NF_GET_VAR_DOUBLE(nid, nvarid, rain_fall_glo)
-#else
-      ierr = NF_GET_VAR_REAL(nid, nvarid, rain_fall_glo)
-#endif
-      IF (ierr.NE.NF_NOERR) THEN
-         PRINT*, 'phyetat0: Lecture echouee pour <rain_f>'
-         CALL abort
-      ENDIF
-      xmin = 1.0E+20
-      xmax = -1.0E+20
-      DO i = 1, klon_glo
-         xmin = MIN(rain_fall_glo(i),xmin)
-         xmax = MAX(rain_fall_glo(i),xmax)
+      CALL get_field("rain_f",rain_fall)
+      xmin = 1.0E+20
+      xmax = -1.0E+20
+      DO i = 1, klon
+         xmin = MIN(rain_fall(i),xmin)
+         xmax = MAX(rain_fall(i),xmax)
       ENDDO
       PRINT*,'Precipitation liquide rain_f:', xmin, xmax
@@ -819,23 +502,10 @@
 c Lecture precipitation solide:
 c
-      ierr = NF_INQ_VARID (nid, "snow_f", nvarid)
-      IF (ierr.NE.NF_NOERR) THEN
-         PRINT*, 'phyetat0: Le champ <snow_f> est absent'
-         CALL abort
-      ENDIF
-#ifdef NC_DOUBLE
-      ierr = NF_GET_VAR_DOUBLE(nid, nvarid, snow_fall_glo)
-#else
-      ierr = NF_GET_VAR_REAL(nid, nvarid, snow_fall_glo)
-#endif
-      IF (ierr.NE.NF_NOERR) THEN
-         PRINT*, 'phyetat0: Lecture echouee pour <snow_f>'
-         CALL abort
-      ENDIF
-      xmin = 1.0E+20
-      xmax = -1.0E+20
-      DO i = 1, klon_glo
-         xmin = MIN(snow_fall_glo(i),xmin)
-         xmax = MAX(snow_fall_glo(i),xmax)
+      CALL get_field("snow_f",snow_fall)
+      xmin = 1.0E+20
+      xmax = -1.0E+20
+      DO i = 1, klon
+         xmin = MIN(snow_fall(i),xmin)
+         xmax = MAX(snow_fall(i),xmax)
       ENDDO
       PRINT*,'Precipitation solide snow_f:', xmin, xmax
@@ -843,25 +513,15 @@
 c Lecture rayonnement solaire au sol:
 c
-      ierr = NF_INQ_VARID (nid, "solsw", nvarid)
-      IF (ierr.NE.NF_NOERR) THEN
+      CALL get_field("solsw",solsw,found)
+      IF (.NOT. found) THEN
          PRINT*, 'phyetat0: Le champ <solsw> est absent'
          PRINT*, 'mis a zero'
-         solsw_glo = 0.
-      ELSE
-#ifdef NC_DOUBLE
-        ierr = NF_GET_VAR_DOUBLE(nid, nvarid, solsw_glo)
-#else
-        ierr = NF_GET_VAR_REAL(nid, nvarid, solsw_glo)
-#endif
-        IF (ierr.NE.NF_NOERR) THEN
-          PRINT*, 'phyetat0: Lecture echouee pour <solsw>'
-          CALL abort
-        ENDIF
-      ENDIF
-      xmin = 1.0E+20
-      xmax = -1.0E+20
-      DO i = 1, klon_glo
-         xmin = MIN(solsw_glo(i),xmin)
-         xmax = MAX(solsw_glo(i),xmax)
+         solsw(:) = 0.
+      ENDIF
+      xmin = 1.0E+20
+      xmax = -1.0E+20
+      DO i = 1, klon
+         xmin = MIN(solsw(i),xmin)
+         xmax = MAX(solsw(i),xmax)
       ENDDO
       PRINT*,'Rayonnement solaire au sol solsw:', xmin, xmax
@@ -869,25 +529,15 @@
 c Lecture rayonnement IF au sol:
 c
-      ierr = NF_INQ_VARID (nid, "sollw", nvarid)
-      IF (ierr.NE.NF_NOERR) THEN
+      CALL get_field("sollw",sollw,found)
+      IF (.NOT. found) THEN
          PRINT*, 'phyetat0: Le champ <sollw> est absent'
          PRINT*, 'mis a zero'
-         sollw_glo = 0.
-      ELSE
-#ifdef NC_DOUBLE
-        ierr = NF_GET_VAR_DOUBLE(nid, nvarid, sollw_glo)
-#else
-        ierr = NF_GET_VAR_REAL(nid, nvarid, sollw_glo)
-#endif
-        IF (ierr.NE.NF_NOERR) THEN
-          PRINT*, 'phyetat0: Lecture echouee pour <sollw>'
-          CALL abort
-        ENDIF
-      ENDIF
-      xmin = 1.0E+20
-      xmax = -1.0E+20
-      DO i = 1, klon_glo
-         xmin = MIN(sollw_glo(i),xmin)
-         xmax = MAX(sollw_glo(i),xmax)
+         sollw = 0.
+      ENDIF
+      xmin = 1.0E+20
+      xmax = -1.0E+20
+      DO i = 1, klon
+         xmin = MIN(sollw(i),xmin)
+         xmax = MAX(sollw(i),xmax)
       ENDDO
       PRINT*,'Rayonnement IF au sol sollw:', xmin, xmax
@@ -896,23 +546,13 @@
 c Lecture derive des flux:
 c
-      ierr = NF_INQ_VARID (nid, "fder", nvarid)
-      IF (ierr.NE.NF_NOERR) THEN
+      CALL get_field("fder",fder,found)
+      IF (.NOT. found) THEN
          PRINT*, 'phyetat0: Le champ <fder> est absent'
          PRINT*, 'mis a zero'
          fder = 0.
-      ELSE
-#ifdef NC_DOUBLE
-        ierr = NF_GET_VAR_DOUBLE(nid, nvarid, fder)
-#else
-        ierr = NF_GET_VAR_REAL(nid, nvarid, fder)
-#endif
-        IF (ierr.NE.NF_NOERR) THEN
-          PRINT*, 'phyetat0: Lecture echouee pour <fder>'
-          CALL abort
-        ENDIF
-      ENDIF
-      xmin = 1.0E+20
-      xmax = -1.0E+20
-      DO i = 1, klon_glo
+      ENDIF
+      xmin = 1.0E+20
+      xmax = -1.0E+20
+      DO i = 1, klon
          xmin = MIN(fder(i),xmin)
          xmax = MAX(fder(i),xmax)
